// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0.If a copy of the MPL was not distributed with this
// file, You can obtain one at https ://mozilla.org/MPL/2.0/.

#ifndef AXIS_H
#define AXIS_H

#include "Angle.h"

namespace Passer {
namespace LinearAlgebra {

struct Vector3;

class Axis {
public:
  Angle horizontalAngle;
  Angle verticalAngle;

  Axis();
  Axis(Angle horizontal, Angle vertical);
  Axis(Vector3 v);

  const static Axis forward;
  const static Axis back;
  const static Axis up;
  const static Axis down;
  const static Axis left;
  const static Axis right;

  Vector3 ToVector3();
};

} // namespace LinearAlgebra
} // namespace Passer
using namespace Passer::LinearAlgbra;

#endif